質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.01%

Symfony2.8 security.authentication_utils サービスが存在しないエラーが発生する

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 1,444

ucan

score 546

/login にアクセスしてログイン画面を表示しようとした際に次のようなエラーメッセージが表示されてしまいます。

You have requested a non-existent service "security.authentication_utils".

<?php
namespace App\ExampleBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;

class SecurityController extends Controller
{
    /**
     * @Route("/login", name="login")
     * @Template()
     */
    public function loginAction()
    {
        $helper = $this->get('security.authentication_utils');

        return array(
            'last_username' => $helper->getLastUsername(),
            'error'         => $helper->getLastAuthenticationError(),
        );
    }
}

エラーについて調べたのですが何が原因でこのエラーが表示されているのか、分からない状態です。
エラーについて何か考えられることがありましたらコメントお願いします。

◯開発環境
OS: Windows10
PHP: 5.5.30
Oracle: 11g
Symfony: 2.8.1

◯参考サイト
New in Symfony 2.6: Security component improvements

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+2

同じコードで再現するかな?と思って試してみましたが、再現しませんでした。

こちらに似たようなトラブルの方が。
https://knpuniversity.com/screencast/symfony2-ep2/login-form2#comment-2226759866

古いバージョンからバージョンアップされてたり、vendor 以下のファイルを直接修正してしまっている場合、このようなエラーが発生するかもしれません。

  • 一度、vendor を削除して composer install を再実行すると解消するかもしれません。
  • あるいは、symfony/symfony-standard の composer.jsoncomposer.lock と見比べるとその差異から糸口が見つかるかもしれません。

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2016/01/06 15:25 編集

    回答ありがとうございます!
    問題が発生したプロジェクトはご指摘の通り古いバージョン(2.7系)からアップグレードしたものでした。

    venderを削除してcomposer installを実行したところ、再インストールで途中でエラーとなり、スキップされるバンドルがあったため、古いcomposer.jsonを破棄して、最新のものに置き換えました。

    vender以外のディレクトリもdiffで確認したところ差異がありましたので、最新のものに合わせてマージしました。

    ○参考にした記事
    http://qiita.com/issei-m/items/c108e133c42c3932b03c
    https://github.com/symfony/symfony/blob/2.8/UPGRADE-2.8.md
    http://symfony.com/doc/current/cookbook/assetic/asset_management.html

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.01%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる